{ Autor....: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte

  Programa.: Relgio sem barra de ttulo que pode ser
             arrastado com o mouse.
}

unit uTBClock;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Fechar1: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Fechar1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { A mensagem WM_NCHitTest ocorre sempre que um evento
      do mouse ocorre sobre uma janela. A janela deve responder
      em que parte da janela o mouse se encontra: ttulo, borda,
      rea cliente }
    procedure WMNCHitTest(var Msg: TMessage); message WM_NCHitTest;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMNCHitTest(var Msg: TMessage);
begin
  { Se o boto esquerdo do mouse estiver pressionado... }
  if GetAsyncKeyState(VK_LBUTTON) < 0 then
    { Trata o form como se fosse a barra de ttulo }
    Msg.Result := HTCAPTION
  else
    { Trata o form normalmente como rea cliente }
    Msg.Result := HTCLIENT;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  { Pega a hora atual, converte para string e coloca no Caption
    do Label }
  Label1.Caption := TimeToStr(Time);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Form sem borda }
  BorderStyle := bsNone;

  { Form sempre visvel }
  FormStyle := fsStayOnTop;

  { Ajusta tamanho e posio do form }
  Width := 80;
  Height := 40;
  Left := Screen.Width - Width +1;
  Top := 0;

  { Ajusta posio do Label }
  Label1.Left := 10;
  Label1.Top := 10;

  { Chama o evento OnTimer do Timer1 para iniciar o relrio }
  Timer1Timer(nil);
end;

procedure TForm1.Fechar1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  { Pinta uma moldura no form }
  Canvas.Brush.Style := bsClear; { Somente linha, sem preenchimento }
  Canvas.Rectangle(ClientRect.Left, ClientRect.Top,
    ClientRect.Right, ClientRect.Bottom);
end;

end.
